package com.seeyon.apps.ocip.exchange.collaboration;

import java.util.Locale;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.springframework.web.servlet.LocaleResolver;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.View;
import org.springframework.web.servlet.ViewResolver;
import org.springframework.web.servlet.handler.HandlerInterceptorAdapter;

import com.seeyon.apps.collaboration.util.ColUtil;
import com.seeyon.apps.ocip.exchange.collaboration.util.CollaborationExchageUtil;
import com.seeyon.ctp.common.AppContext;
import com.seeyon.ctp.common.log.CtpLogFactory;

public class OcipCollaborationURLInterceptor extends HandlerInterceptorAdapter {
    private static final Log LOG = CtpLogFactory.getLog(OcipCollaborationURLInterceptor.class);

    public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object handler) throws Exception {
        String method = request.getParameter("method");
        if ("summary".equals(method)) {
            try {
                ModelAndView modelAndView = CollaborationExchageUtil.getOutCollaborationLink(request);
                if (modelAndView != null) {
                    Map<String, Object> model = modelAndView.getModel();
                    String error = (String) model.get("error");
                    if (error != null) {
                        ColUtil.webAlertAndClose(response, error);
                        return false;
                    }
                    ViewResolver viewResolver = (ViewResolver) AppContext.getBean("viewResolver");
                    LocaleResolver localeResolver = (LocaleResolver) AppContext.getBean("localeResolver");
                    Locale locale = Locale.getDefault();
                    if (localeResolver != null) {
                        locale = localeResolver.resolveLocale(request);
                    }
                    View view = viewResolver.resolveViewName(modelAndView.getViewName(), locale);
                    view.render(modelAndView.getModel(), request, response);
                    return false;
                }
            } catch (Exception e) {
                LOG.error("", e);
                //客开 项目名称： [修改功能：] 作者：fzc 修改日期：2018-5-10 start
                ColUtil.webAlertAndClose(response,"无法访问该事务,可能本地代理关闭导致！");
                //客开 项目名称： [修改功能：] 作者：fzc 修改日期：2018-5-10 end
                return false;
            }
        }
        return super.preHandle(request, response, handler);
    }
}
