package com.seeyon.apps.ocip.exchange.collaboration;

import java.util.HashMap;
import java.util.Locale;
import java.util.Map;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.seeyon.apps.collaboration.util.ColUtil;
import com.seeyon.apps.doc.api.DocApi;
import com.seeyon.apps.doc.bo.DocResourceBO;
import com.seeyon.apps.ocip.exchange.collaboration.util.CollaborationExchageUtil;
import com.seeyon.ctp.common.AppContext;
import com.seeyon.ctp.common.log.CtpLogFactory;
import org.apache.commons.logging.Log;
import org.springframework.web.servlet.LocaleResolver;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.View;
import org.springframework.web.servlet.ViewResolver;
import org.springframework.web.servlet.handler.HandlerInterceptorAdapter;

public class OcipDocURLInterceptor extends HandlerInterceptorAdapter {
    private static final Log LOG = CtpLogFactory.getLog(OcipDocURLInterceptor.class);
    private DocApi docApi;

	public void setDocApi(DocApi docApi) {
		this.docApi = docApi;
	}

	@Override
    public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object handler) throws Exception {
        String method = request.getParameter("method");
        if ("docOpenIframeOnlyId".equals(method)) {
            Long docId = Long.valueOf(request.getParameter("docResId"));
            DocResourceBO docResource = docApi.getDocResource(docId);
            //DocResourceBO docResource = docHierarchyManager.getDocResourceById(docId);//文档实例
            if (docResource != null && docResource.getFrType() == 1L || docResource.getFrType() == 9L) {//协同
                Long affairId = docResource.getSourceId();
                try {
                    Map<String, String> paramters = new HashMap<String, String>();
                    paramters.put("affairId", String.valueOf(affairId));
                    ModelAndView modelAndView = CollaborationExchageUtil.getCollaborationModel(paramters);
                    if (modelAndView != null) {
                        Map<String, Object> model = modelAndView.getModel();
                        String error = (String) model.get("error");
                        if (error != null) {
                            ColUtil.webAlertAndClose(response, error);
                            return false;
                        }
                        ViewResolver viewResolver = (ViewResolver) AppContext.getBean("viewResolver");
                        LocaleResolver localeResolver = (LocaleResolver) AppContext.getBean("localeResolver");
                        Locale locale = Locale.getDefault();
                        if (localeResolver != null) {
                            locale = localeResolver.resolveLocale(request);
                        }
                        View view = viewResolver.resolveViewName(modelAndView.getViewName(), locale);
                        view.render(modelAndView.getModel(), request, response);
                        return false;
                    }
                } catch (Exception e) {
                    LOG.error("", e);
                    //客开 项目名称： [修改功能：] 作者：fzc 修改日期：2018-5-10 start
                    ColUtil.webAlertAndClose(response, "无法访问该事务,可能本地代理关闭导致！");
                    //客开 项目名称： [修改功能：] 作者：fzc 修改日期：2018-5-10 end
                    return false;
                }
            }
        }
        return super.preHandle(request, response, handler);
    }
}
