package com.seeyon.apps.ocip.exchange.collaboration.aspect;


import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.seeyon.ctp.common.taglibs.functions.Functions;
import com.seeyon.ctp.util.DBAgent;
import com.seeyon.ctp.util.Strings;
import org.aspectj.lang.ProceedingJoinPoint;

/**
 * SuperviseDao 的aop
 *
 * @author renx 2019-5-29
 */
public class OcipSuperviseDaoAspect {

    /**
     * OCIP-2021 事务发起人催办后，查看明细日志，不显示被催办人
     * com.seeyon.ctp.common.supervise.dao.SuperviseDao#getReceivers(long superviseLogId)
     *
     * @param pjd
     * @return
     * @throws Throwable
     */
    public Object getReceiversAround(ProceedingJoinPoint pjd) throws Throwable {
        Object[] args = pjd.getArgs();
        if (args.length > 0 && args[0] instanceof Long) {
            String hql = "select a.receiver from CtpSuperviseReceiver a where a.logId = :logId";
            Map<String, Object> map = new HashMap();
            map.put("logId", args[0]);
            List list = DBAgent.find(hql, map);
            StringBuilder sb = new StringBuilder();
            for (int i = 0; i < list.size(); ++i) {
                Long receiver = (Long) list.get(i);
                String name = Functions.showMemberName(receiver);
                if (name != null) {
                    sb.append(name + ",");
                }
            }
            String receiverName = sb.toString();
            if (Strings.isNotBlank(receiverName)) {
                receiverName = receiverName.substring(0, receiverName.length() - 1);
            }
            return receiverName;
        }
        return pjd.proceed();
    }
}
